#Template(DinamiCompLocalClass,'DinamiComp Templates - LocalClass'),FAMILY('ABC')
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#!                              Global Application Extension
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#EXTENSION(DinamiCompLocalClass,'DinamiComp Templates - LocalClass - Global Extension'),APPLICATION
#SHEET
  #TAB('General')
    #BOXED('DinamiComp Local Class Template Set'),SECTION,AT(,15,,55)
    #DISPLAY ('DinamiComp Template Set for Clarion 6.1.')
    #DISPLAY ('Copyright 2002 All Rights Reserved WorldWide.')
    #DISPLAY ('')
    #DISPLAY ('Version 1.0')
    #ENDBOXED
    #BOXED('Debugging'),section,AT(,70,,20)
      #Prompt('Disable All DinamiComp Local Class Templates',Check),%DisableDinLocalAll,AT(10)
    #ENDBOXED
  #ENDTAB
#ENDSHEET

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#!                                Procedure Extension
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#EXTENSION(DINLocalC,'DinamiComp Local Class Declarations'),PROCEDURE,REQ(DinamiCompLocalClass)
#SHEET
  #TAB('General')
    #BOXED('Local Class'),section
      #ENABLE(%DisableDinLocalAll = %FALSE)
        #Prompt('Use Local Class',CHECK),%UseLocal,At(10,5)
        #ENABLE(%UseLocal = %TRUE)
          #PROMPT('Local Class Name:',@s200),%DLocalClassName,DEFAULT('MyLocal')
          #PROMPT('Derive from Class Name:',@s200),%DDeriveClassName,DEFAULT('')
        #ENDENABLE
      #ENDENABLE
    #ENDBOXED
  #ENDTAB
  #TAB('Properties/Variables')
        #ENABLE(%UseLocal = %TRUE)
          #BOXED('Class Global Properties/Variables'),section
            #BUTTON('Class Properties/Variables'),MULTI(%DClassVarMultiName,%DVarName &  ' ' & %DVarType & '(' & %DVarSize & ') - Dim Size ('& %DDimSize & ') !'& %DVarComment),INLINE
              #PROMPT('Property Name:',@s150),%DVarName,REQ
              #PROMPT('Property Type:',Drop('Signed|String|CString|Long|Byte')),%DVarType,Default('String'),REQ
              #ENABLE(%DVarType = 'String' or %DVarType = 'CString')
                #PROMPT('Property Size:',@s20),%DVarSize,Default(''),REQ
              #ENDENABLE
              #ENABLE(%DVarType = 'Long' or %DVarType = 'Byte')
                #PROMPT('Initial Value:',@s20),%DVarInitVal,Default(0)
              #ENDENABLE
              #Prompt('Dimensioned?',Check),%DVarDim,AT(10)
              #ENABLE(%DVarDim = %True)
                #PROMPT('Dimension Size:',@s20),%DDimSize,Default(''),REQ
              #ENDENABLE
              #PROMPT('Property Comment:',@s150),%DVarComment,Default('')
            #ENDBUTTON
          #ENDBOXED
        #ENDENABLE
  #ENDTAB
  #TAB('Methods/Procedures')
   #ENABLE(%UseLocal = %TRUE)
     #BUTTON('Methods/Procedures'),MULTI(%DProcedureMultiName,%DProcedureName & ' : Pass Properties = ' & %DProcParamYN),INLINE
       #PROMPT('Method Name:',@S200),%DProcedureName,REQ
       #PROMPT('Method Type:',DROP('None|Derived|Virtual|Private|Public|Protected')),%DProcedureType,REQ,Default('None')
       #PROMPT('Passing Property:',DROP('Yes|No')),%DProcParamYN,DEFAULT('No')
       #ENABLE(%DProcParamYN='Yes')
         #BOXED('Passing Properties/Parameters'),section
          #BUTTON('Passing Properties/Parameters'),MULTI(%DProcParams,%DProcParamsVariable & ' ' & %DProcParamsType),AT(,,180),INLINE
           #PROMPT('Property Name:',@s150),%DProcParamsVariable,REQ
           #PROMPT('Property Type:',Drop('Signed|String|Long|Byte')),%DProcParamsType,Default('String'),REQ
          #ENDBUTTON
         #ENDBOXED
       #ENDENABLE
       #Prompt('Return Procedure?',Check),%DReturnProc,AT(10)
       #ENABLE(%DReturnProc = %True)
          #PROMPT('Return Property && Variable:',@s50),%DReturnVar,Default('Byte'),REQ
       #ENDENABLE
     #ENDBUTTON
   #ENDENABLE
  #ENDTAB
#ENDSHEET
#!
#!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#AT(%LocalDataAfterClasses),PRIORITY(8500)
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#IF (%DisableDinLocalAll = %FALSE)
#IF (%UseLocal = %TRUE)
#EMBED(%DINLocalCClass,'DinamiComp - Local Class Object Definition - Begin')
#!
#!
#!Declare variables to work with
#DECLARE(%ParamStringA)
#DECLARE(%ReturnParamStringA)
#DECLARE(%ParamCounter)
#!
#!
#!Define the class in Local Data Embed
#IF(%DDeriveClassName = '')
%DLocalClassName    Class()
#ELSE
#!Derive from another class
%DLocalClassName    Class(%DDeriveClassName)
#ENDIF
#!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#!Populate Parameters for class in Local Data Embed
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#FOR(%DClassVarMultiName)
#IF(%DVarType='String' or %DVarType = 'CString')
  #IF(%DVarDim = %False)
  #!If String or Cstring and no Dimension size
%DVarName             %DVarType(%DVarSize)                      !%DVarComment
  #!If String or Cstring and Dimension size
  #Else
%DVarName             %DVarType(%DVarSize),DIM(%DDimSize)       !%DVarComment
  #ENDIF
#ELSIF(%DVarDim = %True)
#!If NOT String or Cstring and Dimension size
%DVarName             %DVarType,DIM(%DDimSize)                  !%DVarComment
#ELSE
 #IF(%DVarInitVal = 0)
#!If NOT String or Cstring and no Dimension size or initial value
%DVarName             %DVarType                                 !%DVarComment
 #ELSE
#!If NOT String or Cstring and no Dimension size AND initial value
%DVarName             %DVarType(%DVarInitVal)                   !%DVarComment
 #ENDIF
#ENDIF
#ENDFOR
#!
#!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#!Populate Methods/Procedures in LOCAL DATA
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 #FOR(%DProcedureMultiName)
    #!
    #!
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    #!Build Return properties/parameter string 
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    #IF(%DReturnProc = %True)
       #SET(%ReturnParamStringA,'')
       #SET(%ReturnParamStringA,%DReturnVar & ',Proc')
    #ENDIF
    #!
    #!
    #!Build properties/parameter string for method/procedure in Local Data Embed
    #IF(%DProcParamYN = 'Yes')
       #SET(%ParamStringA,'')
       #SET(%ParamCounter,0)
       #!Loop through all the properties/parameters for this procedure/method
       #FOR(%DProcParams)
          #IF(%ParamCounter = 1)
            #SET(%ParamStringA,%ParamStringA & ', ' & %DProcParamsType & ' ' & %DProcParamsVariable)
          #ELSE
            #SET(%ParamStringA,%DProcParamsType & ' ' & %DProcParamsVariable)
          #ENDIF
          #SET(%ParamCounter,%ParamCounter + 1)
       #ENDFOR
    #ENDIF
    #!
    #!
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#!  Populate Procedure call for method/procedure in Local Data Embed
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    #IF(%DProcParamYN = 'No')                               #!No Parameters
        #If(%DProcedureType='None')                         #!No Derive
           #IF(%DReturnProc = %True)                        #!Have Return Variable
%DProcedureName     Procedure(),%ReturnParamStringA
           #ELSE
%DProcedureName     Procedure()
           #ENDIF
        #Else                                               #!Derived Yes
%DProcedureName     Procedure(),%DProcedureType             
        #ENDIF
   #ELSE                                                    #!!!!!!! Parameters !!!!!!!!!!!
        #If(%DProcedureType='None')                         #!No Derive
           #IF(%DReturnProc = %True)                        #!Have Return Variable
%DProcedureName     Procedure(%ParamStringA),%ReturnParamStringA
           #ELSE
%DProcedureName     Procedure(%ParamStringA)
           #END
        #Else
%DProcedureName     Procedure(%ParamStringA),%DProcedureType
        #ENDIF
   #ENDIF
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 #ENDFOR
#EMBED(%DINLocalCClass,'DinamiComp - Local Class Object Definition - End')
                    End
#ENDIF
#ENDIF
#ENDAT
#!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#At(%LocalProcedures),Description('DinamiComp(Local) - Procedures')
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#!
#!
#!Declare variables to work with
#DECLARE(%ParamStringB)
#DECLARE(%ReturnParamStringB)
#DECLARE(%ParamCounterB)
#!
#!
#!Populate Methods/Procedure in Local Procedures
#FOR(%DProcedureMultiName)
#EMBED(%DINLocalCClassProcedures,'DinamiComp1 - Local Class Procedures - Begin'),%DProcedureName
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    #!Build Return properties/parameter string for method/procedure in LOCAL PROCEDURE Embed
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    #IF(%DReturnProc = %True)
       #SET(%ReturnParamStringB,'')
       #SET(%ReturnParamStringB,'ReturnValue           Byte(),Auto')
    #ENDIF
    #!
    #!
    #!Build properties/parameter string for method/procedure in Local Data Embed
    #IF(%DProcParamYN = 'Yes')
       #SET(%ParamStringB,'')
       #SET(%ParamCounterB,0)
       #!Loop through all the properties/parameters for this procedure/method
       #FOR(%DProcParams)
          #IF(%ParamCounterB = 1)
            #SET(%ParamStringB,%ParamStringB & ', ' & %DProcParamsType & ' ' & %DProcParamsVariable)
          #ELSE
            #SET(%ParamStringB,%DProcParamsType & ' ' & %DProcParamsVariable)
          #ENDIF
          #SET(%ParamCounterB,%ParamCounterB + 1)
       #ENDFOR
    #ENDIF
    #!
    #!
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    #IF(%DProcParamYN = 'No')                               #!No Parameters
        #If(%DProcedureType='None')                         #!No Derive
%DLocalClassName.%DProcedureName     Procedure()
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        #Else
#!If Derived or virtual procedure
%DLocalClassName.%DProcedureName     Procedure(),%DProcedureType
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        #ENDIF
   #ELSE                                                    #!!!!!!! Parameters !!!!!!!!!!!
        #If(%DProcedureType='None')                         #!No derive
%DLocalClassName.%DProcedureName     Procedure(%ParamStringB)
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        #Else
%DLocalClassName.%DProcedureName     Procedure(%ParamStringB),%DProcedureType
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        #ENDIF
   #ENDIF

#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#!                  Code Section Begins Here
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#EMBED(%DINLocalCClassProcedures1,'DinamiComp2 - Local Class Procedure - Data'),%DProcedureName,DATA
#IF(%DReturnProc = %True)
%ReturnParamStringB
#ENDIF

!--------------------------------------------------------------------------------------------------------
   Code             !Remember to add your Local Data above this line and beginning in column 1
!--------------------------------------------------------------------------------------------------------
#EMBED(%DINLocalCClassProcedures2,'DinamiComp3 - Local Class Procedures - Code'),%DProcedureName

#IF(%DReturnProc = %True)
   Return ReturnValue
#ENDIF
#ENDFOR
#!
#!
#ENDAT